#include <stdio.h>

void
calc(long long m, long long q, double target_hit_p) {
	// number of possible combinations
	// number of open queries initiated by the attacker
	// desired hit probability

	double target_miss_p = 1.0 - target_hit_p;
	long n = 0; // number of bogus replies generated by the attacker

	double cum_miss_p = 1.0;
	while(cum_miss_p >= target_miss_p) {
		n++;
		double hit_p = (double)q / (double)(m - (n - 1));
		double miss_p = 1.0 - hit_p;
		cum_miss_p *= miss_p;
	}

	printf("%lld | %lld | %ld | %lf\n", m, q, n, target_hit_p);
}

int
main(int argc, char* argv[]) {
	printf("m | q | n | p\n");

	// calc(1L<<16, 1, 0.5);
	calc(1L<<16, 4, 0.5);
	calc(1L<<16, 200, 0.5);

	// calc(1LL<<32, 1, 0.5);
	calc(1LL<<32, 4, 0.5);
	calc(2LL<<32, 200, 0.5);

	// calc(2LL<<32, 1, 0.0001);
	calc(2LL<<32, 2, 0.0001);
	calc(2LL<<32, 4, 0.0001);

	return 0;
}

